/*
 * ClientGui.java
 *
 * Created on 2 de Dezembro de 2001, 05:36
 */

package gui;

import javax.swing.table.*;
import javax.swing.*;
import java.util.*;
import br.shmem.client.*;
import br.shmem.*;
import br.shmem.util.*;
import java.io.*;

/**
 *
 * @author crolmos & tminc
 */
public class ClientGui extends javax.swing.JFrame {
    
    /** Creates new form ClientGui */
    public ClientGui() {
        super("Distributed Shared Memory Client");
        initComponents();
        objects.setModel(new ObjectsModel());
        cache.setModel(new ObjectsModel());
        try {
            PipedOutputStream posOutput = new PipedOutputStream();
            PipedInputStream pisOutput = new PipedInputStream(posOutput);
            System.setOut(new PrintStream(posOutput));
            new Thread(new OutputListener(pisOutput)).start();
        }
        catch(IOException e) {
            System.err.println(e.toString());
            System.exit(-1);
        }
        try {
            PipedOutputStream posError = new PipedOutputStream();
            PipedInputStream pisError = new PipedInputStream(posError);
            System.setErr(new PrintStream(posError));
            new Thread(new ErrorListener(pisError)).start();
        }
        catch(IOException e) {
            System.err.println(e.toString());
            System.exit(-1);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        url = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        server = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        localPort = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        serverPort = new javax.swing.JLabel();
        connect = new javax.swing.JButton();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel6 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        share = new javax.swing.JButton();
        Unshare = new javax.swing.JButton();
        validate = new javax.swing.JButton();
        get = new javax.swing.JButton();
        beginTrans = new javax.swing.JButton();
        commit = new javax.swing.JButton();
        rollback = new javax.swing.JButton();
        requery = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jSplitPane2 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        objects = new javax.swing.JTable();
        jScrollPane4 = new javax.swing.JScrollPane();
        cache = new javax.swing.JTable();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        errors = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        output = new javax.swing.JTextArea();
        
        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jLabel1.setText("URL:");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(jLabel1, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        jPanel1.add(url, gridBagConstraints1);
        
        jLabel3.setText("Server:");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(jLabel3, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(server, gridBagConstraints1);
        
        jLabel5.setText("Port:");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(jLabel5, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        jPanel1.add(localPort, gridBagConstraints1);
        
        jLabel7.setText("Port:");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(jLabel7, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(serverPort, gridBagConstraints1);
        
        connect.setText("Connect");
        connect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connectActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 4;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        jPanel1.add(connect, gridBagConstraints1);
        
        getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);
        
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setResizeWeight(0.8);
        jPanel6.setLayout(new java.awt.BorderLayout());
        
        jPanel3.setLayout(new java.awt.GridLayout(0, 1));
        
        jPanel3.setBorder(new javax.swing.border.TitledBorder("Actions"));
        share.setText("Share");
        share.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                shareActionPerformed(evt);
            }
        });
        
        jPanel3.add(share);
        
        Unshare.setText("Unshare");
        Unshare.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                UnshareActionPerformed(evt);
            }
        });
        
        jPanel3.add(Unshare);
        
        validate.setText("Validate");
        validate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                validateActionPerformed(evt);
            }
        });
        
        jPanel3.add(validate);
        
        get.setText("Get");
        get.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getActionPerformed(evt);
            }
        });
        
        jPanel3.add(get);
        
        beginTrans.setText("Begin Trans");
        beginTrans.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                beginTransActionPerformed(evt);
            }
        });
        
        jPanel3.add(beginTrans);
        
        commit.setText("Commit");
        commit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                commitActionPerformed(evt);
            }
        });
        
        jPanel3.add(commit);
        
        rollback.setText("Rollback");
        rollback.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rollbackActionPerformed(evt);
            }
        });
        
        jPanel3.add(rollback);
        
        requery.setText("Requery");
        requery.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                requeryActionPerformed(evt);
            }
        });
        
        jPanel3.add(requery);
        
        jPanel6.add(jPanel3, java.awt.BorderLayout.EAST);
        
        jPanel2.setLayout(new java.awt.BorderLayout());
        
        jSplitPane2.setResizeWeight(0.5);
        jSplitPane2.setPreferredSize(new java.awt.Dimension(600, 200));
        jScrollPane1.setBorder(new javax.swing.border.TitledBorder("Objects"));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(300, 200));
        jScrollPane1.setViewportView(objects);
        
        jSplitPane2.setLeftComponent(jScrollPane1);
        
        jScrollPane4.setBorder(new javax.swing.border.TitledBorder("Cache"));
        jScrollPane4.setPreferredSize(new java.awt.Dimension(300, 200));
        jScrollPane4.setViewportView(cache);
        
        jSplitPane2.setRightComponent(jScrollPane4);
        
        jPanel2.add(jSplitPane2, java.awt.BorderLayout.CENTER);
        
        jPanel6.add(jPanel2, java.awt.BorderLayout.CENTER);
        
        jSplitPane1.setLeftComponent(jPanel6);
        
        jPanel5.setLayout(new javax.swing.BoxLayout(jPanel5, javax.swing.BoxLayout.X_AXIS));
        
        jScrollPane2.setBorder(new javax.swing.border.TitledBorder("Errors"));
        errors.setEditable(false);
        jScrollPane2.setViewportView(errors);
        
        jPanel5.add(jScrollPane2);
        
        jScrollPane3.setBorder(new javax.swing.border.TitledBorder("Output"));
        output.setEditable(false);
        jScrollPane3.setViewportView(output);
        
        jPanel5.add(jScrollPane3);
        
        jSplitPane1.setRightComponent(jPanel5);
        
        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);
        
        pack();
    }//GEN-END:initComponents
    
    private void getActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_getActionPerformed
        // Add your handling code here:
        getSharedObject();
    }//GEN-LAST:event_getActionPerformed
    
    private void rollbackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rollbackActionPerformed
        // Add your handling code here:
        rollback();
    }//GEN-LAST:event_rollbackActionPerformed
    
    private void commitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_commitActionPerformed
        // Add your handling code here:
        commit();
    }//GEN-LAST:event_commitActionPerformed
    
    private void beginTransActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_beginTransActionPerformed
        // Add your handling code here:
        beginTrans();
    }//GEN-LAST:event_beginTransActionPerformed
    
    private void connectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connectActionPerformed
        // Add your handling code here:
        connect();
    }//GEN-LAST:event_connectActionPerformed
    
    private void validateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_validateActionPerformed
        // Add your handling code here:
        validateObject();
    }//GEN-LAST:event_validateActionPerformed
    
    private void UnshareActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_UnshareActionPerformed
        // Add your handling code here:
        unshare();
    }//GEN-LAST:event_UnshareActionPerformed
    
    private void requeryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_requeryActionPerformed
        // Add your handling code here:
        requery();
    }//GEN-LAST:event_requeryActionPerformed
    
    private void shareActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_shareActionPerformed
        // Add your handling code here:
        share();
    }//GEN-LAST:event_shareActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        if(disconnect())
            System.exit(0);
    }//GEN-LAST:event_exitForm
    
    public void connect() {
        try {
            String url = null;
            String serverURL = null;
            int signedPort = -1;
            int serverPort = -1;
            FileInputStream inStream = new FileInputStream("shmem.ini");
            Properties prop = new Properties();
            prop.load(inStream);
            url = prop.getProperty("url");
            if(url == null) {
                System.err.println("Undefined url.");
                System.exit(-1);
            }
            try {
                signedPort = Integer.parseInt(prop.getProperty("port"));
            }
            catch(NumberFormatException e) {
                System.err.println("Undefined port.");
                System.exit(-1);
            }
            serverURL = prop.getProperty("server_url");
            if(serverURL == null) {
                System.err.println("Undefined server_url.");
                System.exit(-1);
            }
            try {
                serverPort = Integer.parseInt(prop.getProperty("server_port"));
            }
            catch(NumberFormatException e) {
                System.err.println("Undefined server_port.");
                System.exit(-1);
            }
            
            this.url.setText(url);
            this.server.setText(serverURL);
            this.localPort.setText(Integer.toString(signedPort));
            this.serverPort.setText(Integer.toString(serverPort));
            
            shmem = new SharedMemory(url, signedPort);
            shmem.setDebugging(true);
            shmem.connect(serverURL, serverPort);
            
            objects.setModel(new ObjectsModel(shmem.getInternalDescriptors()));
            cache.setModel(new ObjectsModel(shmem.getExternalDescriptors()));
        }
        catch(Exception e) {
            System.err.println(e);
        }
    }
    
    public void requery() {
        ((ObjectsModel)objects.getModel()).setObjects(shmem.getInternalDescriptors());
        ((ObjectsModel)cache.getModel()).setObjects(shmem.getExternalDescriptors());
    }
    
    public void share() {
        try {
            String globalName = JOptionPane.showInputDialog(this, "Nome do objeto:");
            MySharedClass obj = new MySharedClass();
            shmem.share(globalName, obj);
        }
        catch(Exception e) {
            System.err.println(e.toString());
            e.printStackTrace(System.err);
        }
    }
    
    public void unshare() {
        try {
            String globalName = JOptionPane.showInputDialog(this, "Nome do objeto:");
            shmem.get(globalName).unshare();
        }
        catch(Exception e) {
            System.err.println(e.toString());
        }
    }
    
    public void validateObject() {
        try {
            String globalName = JOptionPane.showInputDialog(this, "Nome do objeto:");
            shmem.get(globalName).validate();
        }
        catch(Exception e) {
            System.err.println(e.toString());
        }
    }
    
    public void getSharedObject() {
        try {
            String globalName = JOptionPane.showInputDialog(this, "Nome do objeto:");
            shmem.get(globalName);
        }
        catch(Exception e) {
            System.err.println(e.toString());
            e.printStackTrace(System.err);
        }
    }
    
    public void beginTrans() {
        try {
            String globalName = JOptionPane.showInputDialog(this, "Nome do objeto:");
            shmem.get(globalName).beginTrans();
        }
        catch(Exception e) {
            System.err.println(e.toString());
        }
    }
    
    public void commit() {
        try {
            String globalName = JOptionPane.showInputDialog(this, "Nome do objeto:");
            shmem.get(globalName).commit();
        }
        catch(Exception e) {
            System.err.println(e.toString());
        }
    }
    
    public void rollback() {
        try {
            String globalName = JOptionPane.showInputDialog(this, "Nome do objeto:");
            shmem.get(globalName).rollback();
        }
        catch(Exception e) {
            System.err.println(e.toString());
        }
    }
    
    public boolean disconnect() {
        try {
            shmem.disconnect();
            return true;
        }
        catch(Exception e) {
            System.err.println(e.toString());
            return false;
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new ClientGui().show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel url;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel server;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel localPort;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel serverPort;
    private javax.swing.JButton connect;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JButton share;
    private javax.swing.JButton Unshare;
    private javax.swing.JButton validate;
    private javax.swing.JButton get;
    private javax.swing.JButton beginTrans;
    private javax.swing.JButton commit;
    private javax.swing.JButton rollback;
    private javax.swing.JButton requery;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable objects;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTable cache;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea errors;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea output;
    // End of variables declaration//GEN-END:variables
    
    private SharedMemory shmem;
    
    class ObjectsModel extends AbstractTableModel {
        private final String columns[] = {
            "Global Name",
            "Time Stamp",
            "Lease Time",
            "Can write",
            "Reference Class"
        };
        
        private List objects;
        
        public ObjectsModel() {
            objects = new ArrayList();
        }
        
        public ObjectsModel(List objects) {
            this.objects = objects;
        }
        
        public void setObjects(List objects) {
            this.objects = objects;
            fireTableDataChanged();
        }
        
        public int getRowCount() {
            return objects.size();
        }
        
        public int getColumnCount() {
            return columns.length;
        }
        
        public Class getColumnClass(int c) {
            Object obj = getValueAt(0, c);
            if(obj == null)
                return Object.class;
            else
                return obj.getClass();
        }
        
        
        public java.lang.Object getValueAt(int row, int column) {
            SharedObjectDescriptor obj = (SharedObjectDescriptor) objects.get(row);
            
            switch(column) {
                case 0 : return obj.getGlobalName();
                case 1 : return obj.getTimeStamp();
                case 2 : return new Long(obj.getLeaseTime());
                case 3 : return new Boolean(obj.getCanWrite());
                case 4 : return obj.getReferenceClassName();
                default : return null;
            }
        }
        
        public String getColumnName(int column) {
            return columns[column];
        }
    }
    
    class ErrorListener implements Runnable {
        
        BufferedReader in;
        
        public ErrorListener(InputStream in) {
            this.in = new BufferedReader(new InputStreamReader(in));
            
        }
        
        public void run() {
            for(;;) {
                try {
                    if(in.ready())
                        errors.append(in.readLine() + "\n");
                }
                catch(IOException e) {
                }
            }
        }
        
    }
    
    class OutputListener implements Runnable {
        
        BufferedReader in;
        
        public OutputListener(InputStream in) {
            this.in = new BufferedReader(new InputStreamReader(in));
            
        }
        
        public void run() {
            for(;;) {
                try {
                    if(in.ready())
                        output.append(in.readLine() + "\n");
                }
                catch(IOException e) {
                }
            }
        }
        
    }
}
